//=============================================================================
// MenuVisibleSetting.js 2023/10/04
// The MIT License (MIT)
//=============================================================================


/*:ja
 * @plugindesc メニュー項目の表示設定
 * @author surotto daisukiozisan
 *
 * @param アイテム
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param スキル
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param 装備
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param ステータス
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param 並び替え
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param オプション
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param セーブ
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @param ゲーム終了
 * @desc 表示:1 非表示:0
 * @default 1
 *
 * @help 任意のメニュー項目の表示・非表示を設定します
 * 
 */

(function(_global) {
    "use strict";
    var N = document.currentScript.src.replace(/^.*\/([^/]+)\.js$/, '$1');
    var param = PluginManager.parameters(N);

    // ここにプラグイン処理を記載
    
    //パラメータ読み込み
    const param1 = Number(param['アイテム']) || 0;
    const param2 = Number(param['スキル']) || 0;
    const param3 = Number(param['装備']) || 0;
    const param4 = Number(param['ステータス']) || 0;
    const param5 = Number(param['並び替え']) || 0;
    const param6 = Number(param['オプション']) || 0;
    const param7 = Number(param['セーブ']) || 0;
    const param8 = Number(param['ゲーム終了']) || 0;
    
    //メニュー表示設定
    Window_MenuCommand.prototype.makeCommandList = function() {
	    this.addMainCommands();
	    
	    if (param5 == 1) {
	    	this.addFormationCommand();
	    }
	    this.addOriginalCommands();
	    if (param6 == 1) {
	    	this.addOptionsCommand();
	    }
	    if (param7 == 1) {
	    	this.addSaveCommand();
	    }
	    if (param8 == 1) {
	    	this.addGameEndCommand();
	    }
    };
    
    Window_MenuCommand.prototype.addMainCommands = function() {
	    var enabled = this.areMainCommandsEnabled();
	    if (param1 == 1) {
	    	if (this.needsCommand('item')) {
		        this.addCommand(TextManager.item, 'item', enabled);
		    }
	    }
	    if (param2 == 1) {
	    	if (this.needsCommand('skill')) {
		        this.addCommand(TextManager.skill, 'skill', enabled);
		    }
	    }
	    if (param3 == 1) {
	    	if (this.needsCommand('equip')) {
		        this.addCommand(TextManager.equip, 'equip', enabled);
		    }
	    }
	    if (param4 == 1) {
	    	if (this.needsCommand('status')) {
		        this.addCommand(TextManager.status, 'status', enabled);
		    }
	    }
	};
})(this);